Index: branches/jschiess/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/SimulatedAnnealingMainLoop.cs
===================================================================
--- branches/jschiess/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/SimulatedAnnealingMainLoop.cs	(revision 14406)
+++ branches/jschiess/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/SimulatedAnnealingMainLoop.cs	(revision 14452)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -28,227 +28,287 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Algorithms.SimulatedAnnealing {
-  /// <summary>
-  /// An operator which represents a simulated annealing.
-  /// </summary>
-  [Item("SimulatedAnnealingMainLoop", "An operator which represents the main loop of a simulated annealing algorithm.")]
-  [StorableClass]
-  public sealed class SimulatedAnnealingMainLoop : AlgorithmOperator {
-    #region Parameter properties
-    public ValueLookupParameter<IRandom> RandomParameter {
-      get { return (ValueLookupParameter<IRandom>)Parameters["Random"]; }
+namespace HeuristicLab.Algorithms.SimulatedAnnealing
+{
+    [Item("SimulatedAnnealingMainLoop", "An operator which represents the main loop of a simulated annealing algorithm.")]
+    [StorableClass]
+    public sealed class SimulatedAnnealingMainLoop : AlgorithmOperator
+    {
+        #region Strings
+        private const string MoveGeneratorName = "MoveGenerator";
+        private const string MoveEvaluatorName = "MoveEvaluator";
+        private const string MoveMakerName = "MoveMaker";
+        private const string AnnealingOperatorName = "AnnealingOperator";
+        private const string HeatingStrategyOperatorName = "HeatingStrategyOperator";
+        private const string MaximumIterationsName = "MaximumIterations";
+        private const string LowerTemperatureName = "LowerTemperature";
+        private const string AnalyzerName = "Analyzer";
+        private const string RandomName = "Random";
+        private const string EvaluatedMovesName = "EvaluatedMoves";
+        private const string IterationsName = "Iterations";
+        private const string TemperatureStartIndexName = "TemperatureStartIndex";
+        private const string CoolingName = "Cooling";
+        private const string StartTemperatureName = "StartTemperature";
+        private const string EndTemperatureName = "EndTemperature";
+        private const string TemperatureName = "Temperature";
+        private const string ResultsName = "Results";
+        private const string MaximizationName = "Maximization";
+        private const string QualityName = "Quality";
+        private const string BestKnownQualityName = "BestKnownQuality";
+        private const string MoveQualityName = "MoveQuality";
+        private const string IsAcceptedName = "IsAccepted";
+        private const string TerminateName = "Terminate";
+        private const string AcceptanceMemoryName = "AcceptanceMemory";
+        #endregion
+
+        #region Parameter properties
+        public IValueLookupParameter<IRandom> RandomParameter
+        {
+            get { return (IValueLookupParameter<IRandom>)Parameters[RandomName]; }
+        }
+        public IValueLookupParameter<BoolValue> MaximizationParameter
+        {
+            get { return (IValueLookupParameter<BoolValue>)Parameters[MaximizationName]; }
+        }
+        public ILookupParameter<DoubleValue> QualityParameter
+        {
+            get { return (ILookupParameter<DoubleValue>)Parameters[QualityName]; }
+        }
+        public IValueLookupParameter<DoubleValue> BestKnownQualityParameter
+        {
+            get { return (IValueLookupParameter<DoubleValue>)Parameters[BestKnownQualityName]; }
+        }
+        public ILookupParameter<DoubleValue> MoveQualityParameter
+        {
+            get { return (ILookupParameter<DoubleValue>)Parameters[MoveQualityName]; }
+        }
+        public ILookupParameter<DoubleValue> TemperatureParameter
+        {
+            get { return (ILookupParameter<DoubleValue>)Parameters[TemperatureName]; }
+        }
+        public IValueLookupParameter<DoubleValue> LowerTemperatureParameter
+        {
+            get { return (IValueLookupParameter<DoubleValue>)Parameters[LowerTemperatureName]; }
+        }
+        public ILookupParameter<IntValue> IterationsParameter
+        {
+            get { return (ILookupParameter<IntValue>)Parameters[IterationsName]; }
+        }
+        public IValueLookupParameter<IntValue> MaximumIterationsParameter
+        {
+            get { return (IValueLookupParameter<IntValue>)Parameters[MaximumIterationsName]; }
+        }
+        public IValueLookupParameter<IOperator> MoveGeneratorParameter
+        {
+            get { return (IValueLookupParameter<IOperator>)Parameters[MoveGeneratorName]; }
+        }
+        public IValueLookupParameter<IOperator> MoveEvaluatorParameter
+        {
+            get { return (IValueLookupParameter<IOperator>)Parameters[MoveEvaluatorName]; }
+        }
+        public IValueLookupParameter<IOperator> MoveMakerParameter
+        {
+            get { return (IValueLookupParameter<IOperator>)Parameters[MoveMakerName]; }
+        }
+        public IValueLookupParameter<IOperator> AnnealingOperatorParameter
+        {
+            get { return (IValueLookupParameter<IOperator>)Parameters[AnnealingOperatorName]; }
+        }
+        public IValueLookupParameter<IOperator> HeatingStrategyOperatorParameter
+        {
+            get { return (IValueLookupParameter<IOperator>)Parameters[HeatingStrategyOperatorName]; }
+        }
+        public IValueLookupParameter<IOperator> AnalyzerParameter
+        {
+            get { return (IValueLookupParameter<IOperator>)Parameters[AnalyzerName]; }
+        }
+        public IValueLookupParameter<VariableCollection> ResultsParameter
+        {
+            get { return (IValueLookupParameter<VariableCollection>)Parameters[ResultsName]; }
+        }
+        public ILookupParameter<IntValue> EvaluatedMovesParameter
+        {
+            get { return (ILookupParameter<IntValue>)Parameters[EvaluatedMovesName]; }
+        }
+        public ILookupParameter<DoubleValue> StartTemperatureParameter
+        {
+            get { return (ILookupParameter<DoubleValue>)Parameters[StartTemperatureName]; }
+        }
+        public ILookupParameter<DoubleValue> EndTemperatureParameter
+        {
+            get { return (ILookupParameter<DoubleValue>)Parameters[EndTemperatureName]; }
+        }
+        public ILookupParameter<IntValue> TemperatureStartIndexParameter
+        {
+            get { return (ILookupParameter<IntValue>)Parameters[TemperatureStartIndexName]; }
+        }
+        public ILookupParameter<BoolValue> CoolingParameter
+        {
+            get { return (ILookupParameter<BoolValue>)Parameters[CoolingName]; }
+        }
+        #endregion
+
+        [StorableConstructor]
+        private SimulatedAnnealingMainLoop(bool deserializing) : base(deserializing) { }
+        private SimulatedAnnealingMainLoop(SimulatedAnnealingMainLoop original, Cloner cloner)
+          : base(original, cloner)
+        {
+        }
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new SimulatedAnnealingMainLoop(this, cloner);
+        }
+        public SimulatedAnnealingMainLoop()
+          : base()
+        {
+            Initialize();
+        }
+
+        private void Initialize()
+        {
+            #region Create parameters
+            Parameters.Add(new ValueLookupParameter<IRandom>(RandomName, "A pseudo random number generator."));
+            Parameters.Add(new ValueLookupParameter<BoolValue>(MaximizationName, "True if the problem is a maximization problem, otherwise false."));
+            Parameters.Add(new LookupParameter<DoubleValue>(QualityName, "The value which represents the quality of a solution."));
+            Parameters.Add(new ValueLookupParameter<DoubleValue>(BestKnownQualityName, "The best known quality value found so far."));
+            Parameters.Add(new LookupParameter<DoubleValue>(MoveQualityName, "The value which represents the quality of a move."));
+            Parameters.Add(new LookupParameter<DoubleValue>(TemperatureName, "The current temperature."));
+            Parameters.Add(new ValueLookupParameter<DoubleValue>(LowerTemperatureName, "The lower bound of the temperature."));
+            Parameters.Add(new LookupParameter<IntValue>(IterationsName, "The number of iterations."));
+            Parameters.Add(new ValueLookupParameter<IntValue>(MaximumIterationsName, "The maximum number of iterations which should be processed."));
+
+            Parameters.Add(new ValueLookupParameter<IOperator>(MoveGeneratorName, "The operator that generates the moves."));
+            Parameters.Add(new ValueLookupParameter<IOperator>(MoveEvaluatorName, "The operator that evaluates a move."));
+            Parameters.Add(new ValueLookupParameter<IOperator>(MoveMakerName, "The operator that performs a move and updates the quality."));
+            Parameters.Add(new ValueLookupParameter<IOperator>(AnnealingOperatorName, "The operator that cools the temperature."));
+            Parameters.Add(new ValueLookupParameter<IOperator>(HeatingStrategyOperatorName, "The operator that heats the temperature."));
+
+            Parameters.Add(new ValueLookupParameter<IOperator>(AnalyzerName, "The operator used to analyze each generation."));
+            Parameters.Add(new ValueLookupParameter<VariableCollection>(ResultsName, "The variable collection where results should be stored."));
+            Parameters.Add(new LookupParameter<IntValue>(EvaluatedMovesName, "The number of evaluated moves."));
+
+            Parameters.Add(new LookupParameter<IntValue>(TemperatureStartIndexName, "The index where the annealing or heating was last changed."));
+            Parameters.Add(new LookupParameter<BoolValue>(CoolingName, "True when the temperature should be cooled, false otherwise."));
+            Parameters.Add(new LookupParameter<DoubleValue>(StartTemperatureName, "The temperature from which cooling or reheating should occur."));
+            Parameters.Add(new LookupParameter<DoubleValue>(EndTemperatureName, "The temperature to which should be cooled or heated."));
+            #endregion
+
+            #region Create operators
+            var variableCreator = new VariableCreator();
+            var ssp1 = new SubScopesProcessor();
+            var analyzer1 = new Placeholder();
+            var ssp2 = new SubScopesProcessor();
+            var resultsCollector = new ResultsCollector();
+            var mainProcessor = new SubScopesProcessor();
+            var moveGenerator = new Placeholder();
+            var moveEvaluationProcessor = new SubScopesProcessor();
+            var moveEvaluator = new Placeholder();
+            var evaluatedMovesCounter = new IntCounter();
+            var qualityComparator = new ProbabilisticQualityComparator();
+            var acceptsQualityBranch = new ConditionalBranch();
+            var moveMaker = new Placeholder();
+            var temperatureController = new TemperatureController();
+            var subScopesRemover = new SubScopesRemover();
+            var iterationsCounter = new IntCounter();
+            var iterationsComparator = new Comparator();
+            var ssp3 = new SubScopesProcessor();
+            var analyzer2 = new Placeholder();
+            var iterationsTermination = new ConditionalBranch();
+
+            variableCreator.Name = "Initialize Memory";
+            variableCreator.CollectedValues.Add(new ValueParameter<ItemList<BoolValue>>(AcceptanceMemoryName, new ItemList<BoolValue>()));
+
+            analyzer1.Name = "Analyzer";
+            analyzer1.OperatorParameter.ActualName = AnalyzerParameter.Name;
+
+            moveGenerator.Name = "Move generator";
+            moveGenerator.OperatorParameter.ActualName = MoveGeneratorParameter.Name;
+
+            moveEvaluator.Name = "Move evaluator";
+            moveEvaluator.OperatorParameter.ActualName = MoveEvaluatorParameter.Name;
+
+            evaluatedMovesCounter.Name = "EvaluatedMoves++";
+            evaluatedMovesCounter.ValueParameter.ActualName = EvaluatedMovesParameter.Name;
+            evaluatedMovesCounter.Increment = new IntValue(1);
+
+            qualityComparator.LeftSideParameter.ActualName = MoveQualityParameter.Name;
+            qualityComparator.RightSideParameter.ActualName = QualityParameter.Name;
+            qualityComparator.ResultParameter.ActualName = IsAcceptedName;
+            qualityComparator.DampeningParameter.ActualName = TemperatureParameter.Name;
+
+            acceptsQualityBranch.ConditionParameter.ActualName = IsAcceptedName;
+
+            moveMaker.Name = "Move maker";
+            moveMaker.OperatorParameter.ActualName = MoveMakerParameter.Name;
+
+            temperatureController.AnnealingOperatorParameter.ActualName = AnnealingOperatorParameter.Name;
+            temperatureController.AcceptanceMemoryParameter.ActualName = AcceptanceMemoryName;
+            temperatureController.CoolingParameter.ActualName = CoolingParameter.Name;
+            temperatureController.EndTemperatureParameter.ActualName = EndTemperatureParameter.Name;
+            temperatureController.HeatingStrategyOperatorParameter.ActualName = HeatingStrategyOperatorParameter.Name;
+            temperatureController.IsAcceptedParameter.ActualName = IsAcceptedName;
+            temperatureController.IterationsParameter.ActualName = IterationsParameter.Name;
+            temperatureController.LowerTemperatureParameter.ActualName = LowerTemperatureParameter.Name;
+            temperatureController.MaximumIterationsParameter.ActualName = MaximumIterationsParameter.Name;
+            temperatureController.StartTemperatureParameter.ActualName = StartTemperatureParameter.Name;
+            temperatureController.TemperatureParameter.ActualName = TemperatureParameter.Name;
+            temperatureController.TemperatureStartIndexParameter.ActualName = TemperatureStartIndexParameter.Name;
+
+            subScopesRemover.RemoveAllSubScopes = true;
+
+            iterationsCounter.Name = "Iterations++";
+            iterationsCounter.Increment = new IntValue(1);
+            iterationsCounter.ValueParameter.ActualName = IterationsParameter.Name;
+
+            iterationsComparator.Name = "Iterations >= MaximumIterations";
+            iterationsComparator.LeftSideParameter.ActualName = IterationsParameter.Name;
+            iterationsComparator.RightSideParameter.ActualName = MaximumIterationsParameter.Name;
+            iterationsComparator.ResultParameter.ActualName = TerminateName;
+            iterationsComparator.Comparison.Value = ComparisonType.GreaterOrEqual;
+
+            analyzer2.Name = "Analyzer (placeholder)";
+            analyzer2.OperatorParameter.ActualName = AnalyzerParameter.Name;
+
+            iterationsTermination.Name = "Iterations termination condition";
+            iterationsTermination.ConditionParameter.ActualName = TerminateName;
+            #endregion
+
+            #region Create operator graph
+            OperatorGraph.InitialOperator = variableCreator;
+            variableCreator.Successor = ssp1;
+            ssp1.Operators.Add(analyzer1);
+            ssp1.Successor = ssp2;
+            analyzer1.Successor = null;
+            ssp2.Operators.Add(resultsCollector);
+            ssp2.Successor = mainProcessor;
+            resultsCollector.Successor = null;
+            mainProcessor.Operators.Add(moveGenerator);
+            mainProcessor.Successor = iterationsCounter;
+            moveGenerator.Successor = moveEvaluationProcessor;
+            moveEvaluationProcessor.Operators.Add(moveEvaluator);
+            moveEvaluationProcessor.Successor = evaluatedMovesCounter;
+            moveEvaluator.Successor = qualityComparator;
+            qualityComparator.Successor = acceptsQualityBranch;
+            acceptsQualityBranch.TrueBranch = moveMaker;
+            acceptsQualityBranch.FalseBranch = null;
+            acceptsQualityBranch.Successor = temperatureController;
+            moveMaker.Successor = null;
+            temperatureController.Successor = null;
+            evaluatedMovesCounter.Successor = subScopesRemover;
+            subScopesRemover.Successor = null;
+            iterationsCounter.Successor = iterationsComparator;
+            iterationsComparator.Successor = ssp3;
+            ssp3.Operators.Add(analyzer2);
+            ssp3.Successor = iterationsTermination;
+            iterationsTermination.TrueBranch = null;
+            iterationsTermination.FalseBranch = mainProcessor;
+            #endregion
+        }
+
+        public override IOperation Apply()
+        {
+            if (MoveGeneratorParameter.ActualValue == null || MoveEvaluatorParameter.ActualValue == null || MoveMakerParameter.ActualValue == null)
+                return null;
+            return base.Apply();
+        }
     }
-    public ValueLookupParameter<BoolValue> MaximizationParameter {
-      get { return (ValueLookupParameter<BoolValue>)Parameters["Maximization"]; }
-    }
-    public LookupParameter<DoubleValue> QualityParameter {
-      get { return (LookupParameter<DoubleValue>)Parameters["Quality"]; }
-    }
-    public ValueLookupParameter<DoubleValue> BestKnownQualityParameter {
-      get { return (ValueLookupParameter<DoubleValue>)Parameters["BestKnownQuality"]; }
-    }
-    public LookupParameter<DoubleValue> MoveQualityParameter {
-      get { return (LookupParameter<DoubleValue>)Parameters["MoveQuality"]; }
-    }
-    public ILookupParameter<DoubleValue> TemperatureParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["Temperature"]; }
-    }
-    public ValueLookupParameter<DoubleValue> StartTemperatureParameter {
-      get { return (ValueLookupParameter<DoubleValue>)Parameters["StartTemperature"]; }
-    }
-    public ValueLookupParameter<DoubleValue> EndTemperatureParameter {
-      get { return (ValueLookupParameter<DoubleValue>)Parameters["EndTemperature"]; }
-    }
-    public ValueLookupParameter<IntValue> InnerIterationsParameter {
-      get { return (ValueLookupParameter<IntValue>)Parameters["InnerIterations"]; }
-    }
-    public LookupParameter<IntValue> IterationsParameter {
-      get { return (LookupParameter<IntValue>)Parameters["Iterations"]; }
-    }
-    public ValueLookupParameter<IntValue> MaximumIterationsParameter {
-      get { return (ValueLookupParameter<IntValue>)Parameters["MaximumIterations"]; }
-    }
-    public ValueLookupParameter<IOperator> MoveGeneratorParameter {
-      get { return (ValueLookupParameter<IOperator>)Parameters["MoveGenerator"]; }
-    }
-    public ValueLookupParameter<IOperator> MoveEvaluatorParameter {
-      get { return (ValueLookupParameter<IOperator>)Parameters["MoveEvaluator"]; }
-    }
-    public ValueLookupParameter<IOperator> MoveMakerParameter {
-      get { return (ValueLookupParameter<IOperator>)Parameters["MoveMaker"]; }
-    }
-    public ValueLookupParameter<IOperator> AnnealingOperatorParameter {
-      get { return (ValueLookupParameter<IOperator>)Parameters["AnnealingOperator"]; }
-    }
-    public ValueLookupParameter<IOperator> AnalyzerParameter {
-      get { return (ValueLookupParameter<IOperator>)Parameters["Analyzer"]; }
-    }
-    public ValueLookupParameter<VariableCollection> ResultsParameter {
-      get { return (ValueLookupParameter<VariableCollection>)Parameters["Results"]; }
-    }
-    public LookupParameter<IntValue> EvaluatedMovesParameter {
-      get { return (LookupParameter<IntValue>)Parameters["EvaluatedMoves"]; }
-    }
-    #endregion
-
-    [StorableConstructor]
-    private SimulatedAnnealingMainLoop(bool deserializing) : base(deserializing) { }
-    private SimulatedAnnealingMainLoop(SimulatedAnnealingMainLoop original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new SimulatedAnnealingMainLoop(this, cloner);
-    }
-    public SimulatedAnnealingMainLoop()
-      : base() {
-      Initialize();
-    }
-
-    private void Initialize() {
-      #region Create parameters
-      Parameters.Add(new ValueLookupParameter<IRandom>("Random", "A pseudo random number generator."));
-      Parameters.Add(new ValueLookupParameter<BoolValue>("Maximization", "True if the problem is a maximization problem, otherwise false."));
-      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The value which represents the quality of a solution."));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("BestKnownQuality", "The best known quality value found so far."));
-      Parameters.Add(new LookupParameter<DoubleValue>("MoveQuality", "The value which represents the quality of a move."));
-      Parameters.Add(new LookupParameter<DoubleValue>("Temperature", "The current temperature."));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("StartTemperature", "The initial temperature."));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("EndTemperature", "The end temperature."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("InnerIterations", "The amount of inner iterations (number of moves before temperature is adjusted again)."));
-      Parameters.Add(new LookupParameter<IntValue>("Iterations", "The number of iterations."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("MaximumIterations", "The maximum number of iterations which should be processed."));
-
-      Parameters.Add(new ValueLookupParameter<IOperator>("MoveGenerator", "The operator that generates the moves."));
-      Parameters.Add(new ValueLookupParameter<IOperator>("MoveEvaluator", "The operator that evaluates a move."));
-      Parameters.Add(new ValueLookupParameter<IOperator>("MoveMaker", "The operator that performs a move and updates the quality."));
-      Parameters.Add(new ValueLookupParameter<IOperator>("AnnealingOperator", "The operator that modifies the temperature."));
-
-      Parameters.Add(new ValueLookupParameter<IOperator>("Analyzer", "The operator used to analyze each generation."));
-      Parameters.Add(new ValueLookupParameter<VariableCollection>("Results", "The variable collection where results should be stored."));
-      Parameters.Add(new LookupParameter<IntValue>("EvaluatedMoves", "The number of evaluated moves."));
-      #endregion
-
-      #region Create operators
-      Assigner temperatureInitializer = new Assigner();
-      ResultsCollector resultsCollector1 = new ResultsCollector();
-      SubScopesProcessor subScopesProcessor0 = new SubScopesProcessor();
-      Placeholder analyzer1 = new Placeholder();
-      SubScopesProcessor sssp = new SubScopesProcessor();
-      ResultsCollector resultsCollector = new ResultsCollector();
-      Placeholder annealingOperator = new Placeholder();
-      UniformSubScopesProcessor mainProcessor = new UniformSubScopesProcessor();
-      Placeholder moveGenerator = new Placeholder();
-      UniformSubScopesProcessor moveEvaluationProcessor = new UniformSubScopesProcessor();
-      Placeholder moveEvaluator = new Placeholder();
-      SubScopesCounter subScopesCounter = new SubScopesCounter();
-      ProbabilisticQualityComparator qualityComparator = new ProbabilisticQualityComparator();
-      ConditionalBranch improvesQualityBranch = new ConditionalBranch();
-      Placeholder moveMaker = new Placeholder();
-      SubScopesRemover subScopesRemover = new SubScopesRemover();
-      IntCounter iterationsCounter = new IntCounter();
-      Comparator iterationsComparator = new Comparator();
-      SubScopesProcessor subScopesProcessor1 = new SubScopesProcessor();
-      Placeholder analyzer2 = new Placeholder();
-      ConditionalBranch iterationsTermination = new ConditionalBranch();
-
-      temperatureInitializer.LeftSideParameter.ActualName = TemperatureParameter.ActualName;
-      temperatureInitializer.RightSideParameter.ActualName = StartTemperatureParameter.Name;
-
-      resultsCollector1.CollectedValues.Add(new LookupParameter<IntValue>(IterationsParameter.Name));
-      resultsCollector1.ResultsParameter.ActualName = ResultsParameter.Name;
-
-      analyzer1.Name = "Analyzer (placeholder)";
-      analyzer1.OperatorParameter.ActualName = AnalyzerParameter.Name;
-
-      annealingOperator.Name = "Annealing operator (placeholder)";
-      annealingOperator.OperatorParameter.ActualName = AnnealingOperatorParameter.Name;
-
-      moveGenerator.Name = "Move generator (placeholder)";
-      moveGenerator.OperatorParameter.ActualName = MoveGeneratorParameter.Name;
-
-      moveEvaluator.Name = "Move evaluator (placeholder)";
-      moveEvaluator.OperatorParameter.ActualName = MoveEvaluatorParameter.Name;
-
-      subScopesCounter.Name = "Increment EvaluatedMoves";
-      subScopesCounter.ValueParameter.ActualName = EvaluatedMovesParameter.Name;
-
-      qualityComparator.LeftSideParameter.ActualName = MoveQualityParameter.Name;
-      qualityComparator.RightSideParameter.ActualName = QualityParameter.Name;
-      qualityComparator.ResultParameter.ActualName = "IsBetter";
-      qualityComparator.DampeningParameter.ActualName = "Temperature";
-
-      improvesQualityBranch.ConditionParameter.ActualName = "IsBetter";
-
-      moveMaker.Name = "Move maker (placeholder)";
-      moveMaker.OperatorParameter.ActualName = MoveMakerParameter.Name;
-
-      subScopesRemover.RemoveAllSubScopes = true;
-
-      iterationsCounter.Name = "Increment Iterations";
-      iterationsCounter.Increment = new IntValue(1);
-      iterationsCounter.ValueParameter.ActualName = IterationsParameter.Name;
-
-      iterationsComparator.Name = "Iterations >= MaximumIterations";
-      iterationsComparator.LeftSideParameter.ActualName = IterationsParameter.Name;
-      iterationsComparator.RightSideParameter.ActualName = MaximumIterationsParameter.Name;
-      iterationsComparator.ResultParameter.ActualName = "Terminate";
-      iterationsComparator.Comparison.Value = ComparisonType.GreaterOrEqual;
-
-      analyzer2.Name = "Analyzer (placeholder)";
-      analyzer2.OperatorParameter.ActualName = AnalyzerParameter.Name;
-
-      iterationsTermination.Name = "Iterations termination condition";
-      iterationsTermination.ConditionParameter.ActualName = "Terminate";
-      #endregion
-
-      #region Create operator graph
-      OperatorGraph.InitialOperator = temperatureInitializer;
-      temperatureInitializer.Successor = resultsCollector1;
-      resultsCollector1.Successor = subScopesProcessor0;
-      subScopesProcessor0.Operators.Add(analyzer1);
-      subScopesProcessor0.Successor = sssp;
-      analyzer1.Successor = null;
-      sssp.Operators.Add(resultsCollector);
-      sssp.Successor = annealingOperator;
-      resultsCollector.Successor = null;
-      annealingOperator.Successor = mainProcessor;
-      mainProcessor.Operator = moveGenerator;
-      mainProcessor.Successor = iterationsCounter;
-      moveGenerator.Successor = moveEvaluationProcessor;
-      moveEvaluationProcessor.Operator = moveEvaluator;
-      moveEvaluationProcessor.Successor = subScopesCounter;
-      moveEvaluator.Successor = qualityComparator;
-      qualityComparator.Successor = improvesQualityBranch;
-      improvesQualityBranch.TrueBranch = moveMaker;
-      improvesQualityBranch.FalseBranch = null;
-      improvesQualityBranch.Successor = null;
-      moveMaker.Successor = null;
-      subScopesCounter.Successor = subScopesRemover;
-      subScopesRemover.Successor = null;
-      iterationsCounter.Successor = iterationsComparator;
-      iterationsComparator.Successor = subScopesProcessor1;
-      subScopesProcessor1.Operators.Add(analyzer2);
-      subScopesProcessor1.Successor = iterationsTermination;
-      iterationsTermination.TrueBranch = null;
-      iterationsTermination.FalseBranch = annealingOperator;
-      #endregion
-    }
-
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      // BackwardsCompatibility3.3
-      #region Backwards compatible code (remove with 3.4)
-      if (!Parameters.ContainsKey("Iterations"))
-        Parameters.Add(new LookupParameter<IntValue>("Iterations", "The number of iterations."));
-      if (!Parameters.ContainsKey("Temperature"))
-        Parameters.Add(new LookupParameter<DoubleValue>("Temperature", "The current temperature."));
-      #endregion
-    }
-
-    public override IOperation Apply() {
-      if (MoveGeneratorParameter.ActualValue == null || MoveEvaluatorParameter.ActualValue == null || MoveMakerParameter.ActualValue == null)
-        return null;
-      return base.Apply();
-    }
-  }
 }
